#ifndef FOCO_HDR
#define FOCO_HDR

#include <exec/types.h>

#include <clib/exec_protos.h>
#include <clib/graphics_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/dos_protos.h>
#include <clib/commodities_protos.h>
#include <clib/icon_protos.h>
#include <clib/diskfont_protos.h>

#include <pragma/exec_lib.h>
#include <pragma/graphics_lib.h>
#include <pragma/intuition_lib.h>
#include <pragma/gadtools_lib.h>
#include <pragma/dos_lib.h>
#include <pragma/commodities_lib.h>
#include <pragma/icon_lib.h>
#include <pragma/diskfont_lib.h>

#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <graphics/gfxmacros.h>
#include <utility/tagitem.h>
#include <clib/macros.h>

#include <libraries/gadtools.h>
#include <libraries/commodities.h>

#include <dos/dos.h>
#include <dos/dostags.h>
#include <dos/stdio.h>
#include <dos/dosextens.h>

#include <devices/inputevent.h>
#include <devices/trackdisk.h>

#include <workbench/workbench.h>
#include <workbench/startup.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#endif
